unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Grids, ComCtrls, DBGrids, ZConnection, ZDataset, ZSqlMetadata, db;

type

  { TForm1 }

  TForm1 = class(TForm)
    BuTest02: TButton;
    BuUnderTest: TButton;
    BuShowGenData: TButton;
    BuTest01: TButton;
    Memo1: TMemo;
    StatusBar1: TStatusBar;
    StringGrid1: TStringGrid;
    ZConnection1: TZConnection;
    ZQOrdersAUFLIEFVERWENDEN: TLargeintField;
    ZQOrdersAUFRABATTBETRAG: TFloatField;
    ZQOrdersAUFSKONTO: TFloatField;
    ZQOrdersAUFSKONTOTAGE: TLargeintField;
    ZQOrdersAUFSKONTOVERWENDEN: TLargeintField;
    ZQOrdersAUFSTEUER: TFloatField;
    ZQOrdersAUFSTEUERVERWENDEN: TLargeintField;
    ZQOrdersAUFVERSANDART: TStringField;
    ZQOrdersAUFZAHLFRISTEN: TStringField;
    ZQOrdersord_adresse: TMemoField;
    ZQOrdersord_bemerkung1: TMemoField;
    ZQOrdersord_bemerkung2: TMemoField;
    ZQOrdersord_bemerkung3: TMemoField;
    ZQOrdersord_bemerkungen: TMemoField;
    ZQOrdersord_bestellung: TMemoField;
    ZQOrdersord_datum: TDateTimeField;
    ZQOrdersord_email: TStringField;
    ZQOrdersord_fax: TStringField;
    ZQOrdersord_firma: TStringField;
    ZQOrdersord_forid: TLargeintField;
    ZQOrdersord_gesgewicht: TFloatField;
    ZQOrdersord_id: TLargeintField;
    ZQOrdersord_internet: TStringField;
    ZQOrdersord_land: TStringField;
    ZQOrdersord_liefadresse: TMemoField;
    ZQOrdersord_liefemail: TStringField;
    ZQOrdersord_lieffax: TStringField;
    ZQOrdersord_lieffirma: TStringField;
    ZQOrdersord_liefinternet: TStringField;
    ZQOrdersord_liefland: TStringField;
    ZQOrdersord_liefnachname: TStringField;
    ZQOrdersord_liefort: TStringField;
    ZQOrdersord_liefplz: TStringField;
    ZQOrdersord_liefsel_anrede: TStringField;
    ZQOrdersord_liefstrasse: TStringField;
    ZQOrdersord_lieftelefon: TStringField;
    ZQOrdersord_liefvorname: TStringField;
    ZQOrdersord_nachname: TStringField;
    ZQOrdersord_ort: TStringField;
    ZQOrdersord_plz: TStringField;
    ZQOrdersord_rabatt: TFloatField;
    ZQOrdersord_rabattverwenden: TLargeintField;
    ZQOrdersord_rechnung: TMemoField;
    ZQOrdersord_sel_anrede: TStringField;
    ZQOrdersord_status: TLargeintField;
    ZQOrdersord_strasse: TStringField;
    ZQOrdersord_telefon: TStringField;
    ZQOrdersord_vermerke: TMemoField;
    ZQOrdersord_versandkosten: TFloatField;
    ZQOrdersord_vorname: TStringField;
    ZQuery1: TZQuery;
    ZQOrders: TZQuery;
    ZQOrdersInsert: TZQuery;
    ZQuery1ord_id: TLargeintField;
    procedure BuTest01Click(Sender: TObject);
    procedure BuTest02Click(Sender: TObject);
    procedure BuUnderTestClick(Sender: TObject);
    procedure BuShowGenDataClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  fpjson, jsonscanner, JSONParser, LazLogger, unit2, Unit3;

{$R *.lfm}

function DateTimeToMilliseconds(aDateTime: TDateTime): Int64;
var
  TimeStamp: TTimeStamp;
begin
  {Call DateTimeToTimeStamp to convert DateTime to TimeStamp:}
  TimeStamp:= DateTimeToTimeStamp (aDateTime);
  {Multiply and add to complete the conversion:}
  Result:= TimeStamp.Time;
end;

function ConvertDateFormat(aString : String):String;
begin
  Result := aString;
end;

{ TForm1 }

procedure TForm1.BuTest01Click(Sender: TObject);
var
 inputstring, resultstring: string;
 response: TStringStream;
 so: TJSONParser;
 o, oclone, oclone1: TJSONData;
 strname, strinsert: string;
 i, j, k, l: integer;
 test: string;
 lTimeStart: TDateTime;
 myFileSTream : TFileStream;
 d1,d2,d3 : integer;
begin
  DeleteTable(ZConnection1);
  CreateTable(ZConnection1);
  lTimeStart := Now();
  response := TStringStream.Create(GenerateData);
  DebugLn(Format('[GenerateData] Duration: %d ms', [DateTimeToMilliseconds(Now() - lTimeStart)]));
  // Um die erzeugten Daten zu testen
  myFileSTream := TFileStream.Create('testdaten.json',fmCreate);
  myFileSTream.CopyFrom(response,response.Size);
  myFileSTream.free;
  ZConnection1.Disconnect;
  ZConnection1.AutoCommit:=true;
  ZConnection1.Connect;
  ZConnection1.StartTransaction;
  ZQOrders.Active := True;
  try
   lTimeStart := Now();
   response.Position := 0;
   o := nil;
   oclone := nil;
   so := TJSONParser.Create(response);
   so.UseUTF8;

   oclone := so.Parse;

   DebugLn(Format('[oclone] Duration: %d ms', [DateTimeToMilliseconds(Now() - lTimeStart)]));

   d3 := TJSONObject(oclone).Count;
   for i := 0 to TJSONObject(oclone).Count - 1 do
   begin
     oclone1 := TJSONObject(oclone.Items[i].Clone);
     ZQOrders.Append;
     k := 0;
     d1 := TJSONObject(oclone1).Count;
     for j := 0 to TJSONObject(oclone1).Count - 1 do
     begin
       strname := (TJSONObject(oclone1).Names[j]);
       if k > TJSONObject(oclone1).Count - 1 then
         Break
       else
       begin
         if oclone1.Items[k].AsJSON = UpperCase('NULL') then
           strinsert := ''
         else
         if oclone1.Items[k].AsJSON = 'null' then
           strinsert := ''
         else
         if length(oclone1.Items[k].AsJSON) = 0 then
           strinsert := ''
         else
           strinsert := oclone1.Items[k].AsJSON;

         strinsert := StringReplace(strinsert, '"', '', [rfReplaceAll]);

         for l := 0 to ZQOrders.FieldCount - 1 do
         begin
           test := ZQOrders.Fields[l].Name;
           if ZQOrders.Fields[l].Name = 'ZQOrders' + strname then
           begin
             if zqorders.FieldDefs.Items[l].DataType = ftFloat then
               strinsert := '0' + strinsert;

             if ZQOrders.Fields[l].Name = 'ZQOrdersord_datum' then
               ZQOrders.Fields[l].AsString := ConvertDateFormat(strinsert)
             else
               ZQOrders.Fields[l].AsString := strinsert;
           end;
         end;

       end;
       k := k + 1;
     end;
     oclone1.Free;
   end;
  finally
   so.Free;
   oclone.Free;
   response.Free;
  end;
  ZConnection1.Commit;
  DebugLn(Format('[finish] Duration: %d ms', [DateTimeToMilliseconds(Now() - lTimeStart)]));

end;

procedure TForm1.BuTest02Click(Sender: TObject);
var
 inputstring, resultstring: string;
 s1,s2,s3 : string;
 d1,d2,d3 : integer;
 response: TStringStream;
 myFileSTream : TFileStream;
 so: TJSONParser;
 o, oclone, oclone1: TJSONData;
 strinsert, sumstrinsert, sqlall: string;
 ioclonesplit, iSGCount, i, j, splitcount, splitrest, internK1, internK2: integer;
 lTimeStart: TDateTime;
begin
 //Label1.Caption := datetimetostr(Now, FormatSettings);
 //ZQOrdersDeleteAll.ExecSQL;
 //ZConnection1.AutoCommit := False;
 //Application.ProcessMessages;
 //Screen.Cursor := crHourGlass;
 //ZConnection1.Connected := True;
 //ZQOrders.Active := True;
 //ZQOrders.DisableControls;
 lTimeStart := Now();
 response := TStringStream.Create(GenerateData);
 DebugLn(Format('[GenerateData] Duration: %d ms', [DateTimeToMilliseconds(Now() - lTimeStart)]));
 response.Position:=0;
 // Um die erzeugten Daten zu testen
 myFileSTream := TFileStream.Create('testdaten.json',fmCreate);
 myFileSTream.CopyFrom(response,response.Size);
 myFileSTream.free;
 try
   response.Position := 0;
   o := nil;
   oclone := nil;
   so := TJSONParser.Create(response);
   so.UseUTF8;
   oclone := so.Parse;

   //d1 := o.Count;
   //// es werden die jeweiligen Ebenen des JSON Arrays in eigene TJSONData's geladen
   //// erleichtert das "Durchlaufen" mit Schleifen
   //// oclone wäre die Ebene mit den Feldnamen
   //oclone := o.Items[0].Clone;
   d2 := oclone.Count;
   DebugLn(Format('[JSON oclone] Duration: %d ms', [DateTimeToMilliseconds(Now() - lTimeStart)]));


   // Aufteilen des SQL Strings auf max. 500 DS
   // und Schreiben der DS Bereiche in ein Stringgrid
   //Beispiel: Zeile 1, Spalte 1 = 0, Zeile 1, Spalte 2 = 499
   splitcount := TJSONObject(oclone).Count div 499;
   for ioclonesplit := 0 to splitcount - 1 do
   begin

     StringGrid1.RowCount := ioclonesplit + 1;
     StringGrid1.Cells[0, ioclonesplit] := '0';
     StringGrid1.Cells[1, ioclonesplit] := '499';
   end;
   splitrest := TJSONObject(oclone).Count mod 499;

   if splitrest > 0 then
   begin
     StringGrid1.RowCount := StringGrid1.RowCount + 1;
     //StringGrid1.Cells[0, StringGrid1.RowCount - 1] :=
     //   IntToStr(StrToInt(StringGrid1.Cells[1, StringGrid1.RowCount - 2]) + 1);
     s1 := IntToStr(StrToInt(StringGrid1.Cells[1, StringGrid1.RowCount - 2]) + 1);
     StringGrid1.Cells[0, StringGrid1.RowCount - 1] := s1;

     s2 := IntToStr(TJSONObject(oclone).Count - 1);
     StringGrid1.Cells[1, StringGrid1.RowCount - 1] := s2
   end;

   exit;

   for  iSGCount := 0 to StringGrid1.RowCount - 1 do
   begin
     internK1 := StrToInt(StringGrid1.Cells[0, iSGCount]);
     internK2 := StrToInt(StringGrid1.Cells[1, iSGCount]);
     sqlall := '';

     // Version mit Split (auf max. 500 DS)
     for i := (internK1) to (internK2) do

     // Version ohne Split (975 DS)
     //for i := 0 to TJSONObject(oclone).Count - 1 do
     begin

       // Anzeige Progressbar und Statusbartext
       Application.ProcessMessages;
       StatusBar1.Panels.Items[2].Text :=
         'Datensatz ' + IntToStr(i) + ' von ' + IntToStr(TJSONObject(oclone).Count - 1) +
         ' geladen.';
       Application.ProcessMessages;

       // es werden die jeweiligen Ebenen des JSON Arrays in eigene TJSONData's geladen
       // erleichtert das "Durchlaufen" mit Schleifen
       // oclone1 wäre die Ebene mit den Values
       oclone1 := nil;
       oclone1 := TJSONObject(oclone.Items[i].Clone);
       strinsert := '';
       for j := 0 to TJSONObject(oclone1).Count - 1 do
       begin

         // im json array sind die DS doppelt. einmal mit Feldnamen 0, 1, 2, usw.
         // einmal mit ord_id, ord_forid, usw.
         //mit odd wird die jeweils doppelte Zeile übersprungen
         if Odd(j) then
         else
         begin
           if oclone1.Items[j].AsJSON = 'null' then
             strinsert := '""'
           else
           if length(oclone1.Items[j].AsJSON) = 0 then
             strinsert := '""'
           else
             strinsert := oclone1.Items[j].AsJSON;

           //if strname = '3' then //ord_datum
           // strinsert:= ConvertDateFormat(strinsert);

           //strinsert := (strinsert);

           // Dieses zeichen \= ist in Bemerkungen
           strinsert := StringReplace(strinsert, ' \"', ' ', [rfReplaceAll]);

           sumstrinsert := sumstrinsert + ',' + strinsert;
         end;
       end;

       // komma = ',' am Anfang des strings entfernen
       sumstrinsert := copy(sumstrinsert, 2, length(sumstrinsert));

       //suminsert zum Gesamt SQL string hinzufügen
       sqlall := sqlall + '(' + sumstrinsert + ',"",""' + '),';

       sumstrinsert := '';
     end; // end for i
     sqlall := 'INSERT INTO orders VALUES ' + copy(sqlall, 1, Length(sqlall) - 1);
     try
       ZQOrdersInsert.SQL.Clear;
       ZQOrdersInsert.SQL.Text := sqlall;
       ZQOrdersInsert.ExecSQL;
       ZConnection1.Commit;
     except
       memo1.Lines.Add(sqlall);
     end;
   end; //for mit LS
 finally
   so.Free;
   Screen.Cursor := crDefault;
   ZQOrders.Refresh;
   ZQOrders.EnableControls;
   StatusBar1.Panels.Items[0].Text := '';
   StatusBar1.Panels.Items[2].Text := '';
   ZConnection1.AutoCommit := True;
   Application.ProcessMessages;
 end;
end;


procedure TForm1.BuUnderTestClick(Sender: TObject);
var
  inputstring, resultstring: string;
  response: TStringStream;
  so: TJSONParser;
  o, oclone, oclone1: TJSONData;
  strname, strinsert: string;
  i, j, l: integer;
  test: string;
  lTimeStart: TDateTime;
  myFileSTream : TFileStream;
  d1,d2,d3 : integer;
  strHelp : string;
  MetaData : TZSQLMetadata;
  q : TZQuery;
  asl1,asl2,ains, aSQL : String;
  ocloneCnt: Integer;
  aParam : TParam;
begin
  DeleteTable(ZConnection1);
  CreateTable(ZConnection1);
  lTimeStart := Now();
  response := TStringStream.Create(GenerateData);
  DebugLn(Format('[GenerateData] Duration: %d ms', [DateTimeToMilliseconds(Now() - lTimeStart)]));
  // Um die erzeugten Daten zu testen
  myFileSTream := TFileStream.Create('testdaten.json',fmCreate);
  myFileSTream.CopyFrom(response,response.Size);
  myFileSTream.free;
  ZConnection1.Disconnect;
  ZConnection1.AutoCommit:=true;
  ZConnection1.Connect;
//  ZConnection1.StartTransaction;
  asl1 := 'INSERT INTO [orders] (';
  asl2 := ' VALUES (';
  ains := ' ';
  MetaData := TZSQLMetadata.Create(nil);
  MetaData.Connection := ZConnection1;
  MetaData.MetadataType:= TZMetadataType.mdColumns;
  MetaData.TableName:='orders';
  MetaData.Active:=true;
  MetaData.First;
  while not MetaData.EOF do
  begin
    Memo1.Append(MetaData.FieldByName('COLUMN_NAME').AsString);
    asl1 := asl1 + ains + MetaData.FieldByName('COLUMN_NAME').AsString ;
    asl2 := asl2 + ains + ' :' + MetaData.FieldByName('COLUMN_NAME').AsString;
    ains := ' , ';
    MetaData.Next;
  end;
  aSQL := asl1 + ' )' + asl2 + ' );';
  q := TZQuery.Create(nil);
  q.Connection := ZConnection1;
  q.SQL.Text:=aSQL;
  if q.ParamCheck then DebugLn('Check Ok')
  else DebugLn('Check Nok');

  ZConnection1.StartTransaction;
  ZConnection1.ExecuteDirect('DROP INDEX IF EXISTS [orders_datumidx];');
  ZConnection1.Commit;

  ZConnection1.StartTransaction;
  ZConnection1.ExecuteDirect('PRAGMA synchronous = OFF;');
  ZConnection1.Commit;


  q.Prepare;
  if q.Prepared then DebugLn('Prepared Ok')
  else DebugLn('Prepared Nok');

  ZConnection1.StartTransaction;
  try
    response.Position := 0;
    o := nil;
    oclone := nil;
    so := TJSONParser.Create(response);
    so.UseUTF8;
    oclone := so.Parse;
    DebugLn(Format('[oclone] Duration: %d ms', [DateTimeToMilliseconds(Now() - lTimeStart)]));
    ocloneCnt := TJSONObject(oclone).Count;
    for i := 0 to ocloneCnt - 1 do
    begin
      oclone1 := TJSONObject(oclone.Items[i].Clone);
      d1 := TJSONObject(oclone1).Count;
      for j := 0 to TJSONObject(oclone1).Count - 1 do
      begin
        strname := (TJSONObject(oclone1).Names[j]);
        aParam := q.ParamByName(strname);

        if aParam = nil  then
          Continue; //==> nächstes Feld probieren

        // Behübschen
        if oclone1.Items[j].AsJSON = UpperCase('NULL') then
          strinsert := ''
        else
          if oclone1.Items[j].AsJSON = 'null' then
            strinsert := ''
          else
            if length(oclone1.Items[j].AsJSON) = 0 then
              strinsert := ''
            else
              strinsert := oclone1.Items[j].AsJSON;
        strinsert := StringReplace(strinsert, '"', '', [rfReplaceAll]);

        // Daten aufbessern
        if aParam.DataType = ftFloat then
          strinsert := '0' + strinsert;

        if aParam.Name = 'ord_datum' then
          aParam.AsString := ConvertDateFormat(strinsert)
        else
          aParam.AsString := strinsert;

      end;
      DebugLn(Format('[execute start] Duration: %d ms', [DateTimeToMilliseconds(Now() - lTimeStart)]));
      q.ExecSQL;
      DebugLn(Format('[execute stop] Duration: %d ms', [DateTimeToMilliseconds(Now() - lTimeStart)]));
      oclone1.Free;
    end;
    ZConnection1.Commit;
  finally
    so.Free;
    oclone.Free;
    response.Free;
  end;
  q.Free;
  MetaData.Free;

  ZConnection1.StartTransaction;
  ZConnection1.ExecuteDirect('PRAGMA synchronous = ON;');
  ZConnection1.Commit;

  ZConnection1.StartTransaction;
  ZConnection1.ExecuteDirect('CREATE INDEX [orders_datumidx] ON [orders] ([ord_datum]);');
  ZConnection1.Commit;

  DebugLn(Format('[finish] Duration: %d ms', [DateTimeToMilliseconds(Now() - lTimeStart)]));
end;

procedure TForm1.BuShowGenDataClick(Sender: TObject);
begin
  Memo1.Text:= GenerateData;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  DBName: String;
begin
  DBName := ExtractFilePath(ParamStr(0)) + 'TestData.sq3';
  TestAndCreateDB(DBName,ZConnection1);
  DeleteTable(ZConnection1);
  CreateTable(ZConnection1);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin

end;

end.

